#include "rs232.h"

volatile bool uart_receive_complete = false;
char uart_string[20];

void UART_receive_completed()
{
	uart_receive_complete = false;
}
bool UART_receive_complete()
{
	return uart_receive_complete;
}
char* UART_received_string()
{
	return uart_string;
}

void UART_init(void)
{
	UBRRH = UBRR_VAL >> 8;
	UBRRL = UBRR_VAL & 0xFF;
	UCSRB = (1<<RXEN)|(1<<TXEN)|(1<<RXCIE); 
	UCSRC = (1<<UCSZ1)|(1<<UCSZ0);
}

uint8_t UART_peekchar(void)					// Auf Zeichen im UART Eingang prfen
{
	return UCSRA & (1<<RXC);						// sofort zurckkehren und Zustand melden
}
	
uint8_t UART_getc(void)
{
	while (!(UCSRA & (1<<RXC)))   // warten bis Zeichen verfuegbar
	;
	return UDR;                   // Zeichen aus UDR an Aufrufer zurueckgeben
}

uint8_t UART_gets(char* buffer, uint8_t maxLength)
{
	uint8_t index = 0;
	
	while ( index < maxLength && ( buffer[index] = UART_getc() ) != '\0' )
	{
		index++;
	}
	if ( index < maxLength )
		buffer[index] = '\0';
	else
		buffer[maxLength - 1] = '\0';
	
	// bytes read
	return index;
}	

void UART_putchar(char z)					// Zeichen in UART Ausgang geben
{
	while ( !(UCSRA & (1<<UDRE)) )				// Warte bis UART Ausgang frei
			;
	UDR = z;
}
	
void UART_puts(char *s)						// Zeichenkette (String) in UART Ausgang geben
{
	while ( *s )
	{
    UART_putchar(*s);
    s++;
	}
	UART_putchar('\0');
}
	
ISR(USART_RX_vect)
{
		if ( UART_gets(uart_string, 20) > 0 )
		{
			uart_receive_complete = true;
		}
}
