#ifndef RS232_H_
#define RS232_H_

#include <stdlib.h>
#include <avr/interrupt.h>
#include <stdbool.h>

#include "lcd.h"

#ifndef F_CPU
#define F_CPU 14745600UL
#endif

#define BAUD 9600UL

#define UBRR_VAL ((F_CPU+BAUD*8)/(BAUD*16)-1)   // clever runden
#define BAUD_REAL (F_CPU/(16*(UBRR_VAL+1)))     // Reale Baudrate
#define BAUD_ERROR ((BAUD_REAL*1000)/BAUD) // Fehler in Promille, 1000 = kein Fehler.

#if ((BAUD_ERROR<990) || (BAUD_ERROR>1010))
#error Systematischer Fehler der Baudrate grsser 1% und damit zu hoch!
#endif


void UART_init(void);

// Auf Zeichen im UART Eingang prfen
uint8_t UART_peekchar(void);

// Auf Zeichen im UART Eingang warten
uint8_t UART_getc(void);

// Zeichen in UART Ausgang geben
void UART_putchar(char z);

// Zeichenkette (String) in UART Ausgang geben
void UART_puts(char *s);

uint8_t UART_gets(char* buffer, uint8_t maxLength);

bool UART_receive_complete();
void UART_receive_completed();
char* UART_received_string();
/* extern volatile bool uart_receive_complete;
extern char* volatile uart_string; */

#endif /* RS232_H_ */
